#ifndef INJECTOR_H_
#define INJECTOR_H_

#include <cstdint>

#if defined(INJECTOR_EXPORTS)
#define INJECTOR_EXPORT __declspec(dllexport)
#else
#define INJECTOR_EXPORT __declspec(dllimport)
#endif

#if defined(__cplusplus)
extern "C" {
#endif

// Launches `command_line` from `working_directory` and injects `injected_dll`,
// optionally calling `initialize_function` in after injection. If everything 
// goes off without a hitch the process ID will be returned, otherwise 0.
INJECTOR_EXPORT uint32_t LaunchInjected(
    wchar_t const* command_line, 
    wchar_t const* working_directory, 
    wchar_t const* injected_dll, 
    char const* initialize_function
);

#if defined(__cplusplus)
}
#endif

#endif // INJECTOR_H_
